/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        12.11.2007
 Description:    HTTP-Client (empfang einer Webseite)

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#include "http_get.h" 

//!!!!!!*************EXPERIMENTAL*************!!!!!!

//----------------------------------------------------------------------------
//Daten kommen von einem Webserver an!!
void test (unsigned char index)
{
	for (int a = TCP_DATA_START_VAR;a < TCP_DATA_END_VAR;a++)
	{
		HTTPC_DEBUG("%c",eth_buffer[a]);
	}
	tcp_entry[index].time = TCP_TIME_OFF;
	tcp_entry[index].status = ACK_FLAG;
	create_new_tcp_packet(0,index);
}

//----------------------------------------------------------------------------
//HTTP Request an einen Webserver stelle
void http_request (void)
{
	//offnet eine Verbindung zu meinem Webserver
	HTTPC_DEBUG("ARP Request\n\r");
	unsigned long destip;
	destip =(192)+((unsigned long)(168)<<8)+((unsigned long)(0)<<16)+((unsigned long)(102)<<24);
	unsigned int my_http_cp;

	my_http_cp = time;
	
	add_tcp_app (my_http_cp, (void(*)(unsigned char))test);
	
	//ARP Request senden
	arp_request (destip);
	for(unsigned long a=0;a<2000000;a++){asm("nop");};
	
	tcp_port_open (destip,LBBL_ENDIAN_INT(80),LBBL_ENDIAN_INT(my_http_cp));
	
	unsigned long index = MAX_ARP_ENTRY;
	while((index >= MAX_ARP_ENTRY) && (tcp_entry[index].app_status != 1))
	{
		index = tcp_entry_search (destip,LBBL_ENDIAN_INT(80));
		HTTPC_DEBUG("TCP Eintrag nicht gefunden\r\n");
	}
	HTTPC_DEBUG("TCP Eintrag gefunden !!!\r\n");
	tcp_entry[index].first_ack = 1;
	
	ETH_INT_DISABLE;
	memcpy_P(&eth_buffer[TCP_DATA_START],PSTR("GET /xampp/index.php HTTP/1.1\r\nHost:192.168.0.99\r\nConnection: Keep-Alive\r\n\r\n"),77);		
	tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
	create_new_tcp_packet(77,index);
	ETH_INT_ENABLE;
}




